ada: Fix another couple of unchecked conversions to Ada.Tags.Tag
[official-gcc.git] / contrib / gcc_update
blob1bfc67ac91adcbf4d2fcc9ca922330aac19f7533
1 #! /bin/sh
3 # Update a local Subversion, Git or Mercurial tree from the GCC
4 # repository, with an emphasis on treating generated files correctly, so
5 # that autoconf, gperf et al are not required for the ``end'' user.
7 # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009,
8 # 2010, 2011, 2012, 2013, 2014, 2015, 2017 Free Software Foundation
9 # Originally by Gerald Pfeifer <gerald@pfeifer.com>, August 1998.
11 # This script is Free Software, and it can be copied, distributed and
12 # modified as defined in the GNU General Public License. A copy of
13 # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
16 # By default all command-line options are passed to `svn update` or `hg/git
17 # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18 # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
19 # are omitted.
21 # If the first parameter reads --patch, the second parameter is considered
22 # a patch file.
24 # If the first parameter is --touch, no svn operation will be performed,
25 # only generated files that appear to be out of date in the local tree
26 # will be touched.
28 # If the first parameter is --list, a list of the generated files and
29 # their dependencies will be printed; --help prints this message.
31 # If the first parameter is --silent, this script prints nothing other
32 # than error messages; the second parameter is then interpreted as above.
34 # Examples:
36 # contrib/gcc_update -r 8712
37 # contrib/gcc_update --patch some-patch
38 # contrib/gcc_update --touch
39 # contrib/gcc_update --list
42 # Default options used when updating (none).
43 UPDATE_OPTIONS=""
45 # Set the locale to C to make this script work for users with foreign
46 # locale like e.g. French UTF-8.
47 LANG=C
48 LC_ALL=C
49 export LANG LC_ALL
51 ######## Anything below shouldn't be changed by regular users.
53 # Arrange for the value of $0 to be available for functions
54 self=$0
56 # This function prints its arguments to standard output unless
57 # "silent" is set.
58 unset silent
59 chat () {
60 if [ -z "$silent" ]; then
61 echo "$@"
65 # This function prints a list of all generated files, along with their
66 # dependencies. Note that only one target is supported per line: the
67 # colon is stripped from the output.
68 files_and_dependencies () {
69 sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
70 # fixincludes
71 fixincludes/configure: fixincludes/configure.ac fixincludes/aclocal.m4
72 fixincludes/config.h.in: fixincludes/configure.ac fixincludes/aclocal.m4
73 # intl library
74 intl/plural.c: intl/plural.y
75 intl/plural-config.h: intl/plural.y
76 intl/configure: intl/configure.ac intl/aclocal.m4
77 intl/config.h.in: intl/configure.ac intl/aclocal.m4
78 # Now, proceed to gcc automatically generated files
79 gcc/configure: gcc/configure.ac
80 gcc/cstamp-h.in: gcc/configure.ac
81 gcc/config.in: gcc/cstamp-h.in
82 gcc/fixinc/fixincl.x: gcc/fixinc/fixincl.tpl gcc/fixinc/inclhack.def
83 gcc/config/aarch64/aarch64-tune.md: gcc/config/aarch64/aarch64-cores.def gcc/config/aarch64/gentune.sh
84 gcc/config/arm/arm-tune.md: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
85 gcc/config/arm/arm-tables.opt: gcc/config/arm/arm-cpus.in gcc/config/arm/parsecpu.awk
86 gcc/config/c6x/c6x-tables.opt: gcc/config/c6x/c6x-isas.def gcc/config/c6x/genopt.sh
87 gcc/config/c6x/c6x-sched.md: gcc/config/c6x/c6x-sched.md.in gcc/config/c6x/gensched.sh
88 gcc/config/c6x/c6x-mult.md: gcc/config/c6x/c6x-mult.md.in gcc/config/c6x/genmult.sh
89 gcc/config/loongarch/loongarch-str.h: gcc/config/loongarch/genopts/genstr.sh gcc/config/loongarch/genopts/loongarch-strings
90 gcc/config/loongarch/loongarch.opt: gcc/config/loongarch/genopts/genstr.sh gcc/config/loongarch/genopts/loongarch.opt.in
91 gcc/config/m68k/m68k-tables.opt: gcc/config/m68k/m68k-devices.def gcc/config/m68k/m68k-isas.def gcc/config/m68k/m68k-microarchs.def gcc/config/m68k/genopt.sh
92 gcc/config/mips/mips-tables.opt: gcc/config/mips/mips-cpus.def gcc/config/mips/genopt.sh
93 gcc/config/rs6000/rs6000-tables.opt: gcc/config/rs6000/rs6000-cpus.def gcc/config/rs6000/genopt.sh
94 gcc/config/rs6000/fusion.md: gcc/config/rs6000/genfusion.pl
95 # And then, language-specific files
96 gcc/cp/cfns.h: gcc/cp/cfns.gperf
97 gcc/cp/std-name-hint.h: gcc/cp/std-name-hint.gperf
98 gcc/cp/std-name-hint.gperf: gcc/cp/cxxapi-data.csv
99 gcc/m2/configure: gcc/m2/configure.ac
100 gcc/m2/gm2config.h.in: gcc/m2/configure.ac
101 gcc/m2/gm2-libs/config-host: gcc/m2/gm2-libs/config-host.in
102 # testsuite
103 # Without this, _Pragma3.c can have a false negative.
104 gcc/testsuite/gcc.dg/cpp/_Pragma3.c: gcc/testsuite/gcc.dg/cpp/mi1c.h
105 # Similarly, without this, you will see:
106 # direct2s.c:35: warning: current file is older than direct2.c
107 gcc/testsuite/gcc.dg/cpp/direct2s.c: gcc/testsuite/gcc.dg/cpp/direct2.c
108 # lto-plugin
109 lto-plugin/configure: lto-plugin/configure.ac lto-plugin/aclocal.m4
110 lto-plugin/Makefile.in: lto-plugin/Makefile.am lto-plugin/aclocal.m4
111 # tools
112 c++tools/configure: c++tools/configure.ac
113 c++tools/config.h.in: c++tools/configure.ac
114 # And libraries, at last
115 libbanshee/configure: libbanshee/configure.ac
116 libmudflap/configure: libmudflap/configure.ac
117 libobjc/configure: libobjc/configure.ac
118 zlib/aclocal.m4: zlib/configure.ac zlib/acinclude.m4
119 zlib/Makefile.in: zlib/Makefile.am zlib/configure.ac zlib/aclocal.m4
120 zlib/configure: zlib/configure.ac zlib/aclocal.m4
121 fastjar/aclocal.m4: fastjar/configure.ac
122 fastjar/Makefile.in: fastjar/Makefile.am fastjar/configure.ac fastjar/aclocal.m4
123 fastjar/configure: fastjar/configure.ac fastjar/aclocal.m4
124 boehm-gc/aclocal.m4: boehm-gc/configure.ac
125 boehm-gc/Makefile.in: boehm-gc/Makefile.am boehm-gc/configure.ac boehm-gc/aclocal.m4
126 boehm-gc/configure: boehm-gc/configure.ac boehm-gc/aclocal.m4
127 libada/configure: libada/configure.ac
128 libffi/aclocal.m4: libffi/configure.ac libffi/acinclude.m4
129 libffi/Makefile.in: libffi/Makefile.am libffi/configure.ac libffi/aclocal.m4
130 libffi/configure: libffi/configure.ac libffi/aclocal.m4
131 libffi/fficonfig.h.in: libffi/configure.ac libffi/aclocal.m4
132 libgfortran/aclocal.m4: libgfortran/configure.ac libgfortran/acinclude.m4
133 libgfortran/Makefile.in: libgfortran/Makefile.am libgfortran/configure.ac libgfortran/aclocal.m4
134 libgm2/Makefile.in: libgm2/Makefile.am libgm2/configure.ac libgm2/aclocal.m4
135 libgm2/aclocal.m4: libgm2/configure.ac
136 libgm2/libm2cor/Makefile.in: libgm2/libm2cor/Makefile.am
137 libgm2/libm2pim/Makefile.in: libgm2/libm2pim/Makefile.am
138 libgm2/libm2iso/Makefile.in: libgm2/libm2iso/Makefile.am
139 libgm2/libm2log/Makefile.in: libgm2/libm2log/Makefile.am
140 libgm2/libm2min/Makefile.in: libgm2/libm2min/Makefile.am
141 libquadmath/configure: libquadmath/configure.ac libquadmath/aclocal.m4
142 libquadmath/aclocal.m4: libquadmath/configure.ac libquadmath/acinclude.m4
143 libquadmath/Makefile.in: libquadmath/Makefile.am libquadmath/configure.ac libgfortran/aclocal.m4
144 libgfortran/configure: libgfortran/configure.ac libgfortran/aclocal.m4
145 libcody/configure: libcody/configure.ac libcody/config.m4
146 libcpp/aclocal.m4: libcpp/configure.ac
147 libcpp/Makefile.in: libcpp/configure.ac libcpp/aclocal.m4
148 libcpp/configure: libcpp/configure.ac libcpp/aclocal.m4
149 libgomp/aclocal.m4: libgomp/configure.ac libgomp/acinclude.m4
150 libgomp/Makefile.am: libgomp/plugin/Makefrag.am
151 libgomp/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
152 libgomp/testsuite/Makefile.in: libgomp/testsuite/Makefile.am libgomp/aclocal.m4
153 libgomp/configure.ac: libgomp/plugin/configfrag.ac
154 libgomp/configure: libgomp/configure.ac libgomp/aclocal.m4
155 libgomp/config.h.in: libgomp/configure.ac libgomp/aclocal.m4
156 libitm/aclocal.m4: libitm/configure.ac libitm/acinclude.m4
157 libitm/Makefile.in: libitm/Makefile.am libitm/aclocal.m4
158 libitm/testsuite/Makefile.in: libitm/testsuite/Makefile.am libitm/aclocal.m4
159 libitm/configure: libitm/configure.ac libitm/aclocal.m4
160 libitm/config.h.in: libitm/configure.ac libitm/aclocal.m4
161 libatomic/aclocal.m4: libatomic/configure.ac libatomic/acinclude.m4
162 libatomic/Makefile.in: libatomic/Makefile.am libatomic/aclocal.m4
163 libatomic/testsuite/Makefile.in: libatomic/testsuite/Makefile.am libatomic/aclocal.m4
164 libatomic/configure: libatomic/configure.ac libatomic/aclocal.m4
165 libatomic/auto-config.h.in: libatomic/configure.ac libatomic/aclocal.m4
166 libsanitizer/aclocal.m4: libsanitizer/configure.ac libsanitizer/acinclude.m4
167 libsanitizer/Makefile.in: libsanitizer/Makefile.am libsanitizer/aclocal.m4
168 libsanitizer/configure: libsanitizer/configure.ac libsanitizer/aclocal.m4
169 libsanitizer/asan/Makefile.in: libsanitizer/asan/Makefile.am libsanitizer/aclocal.m4
170 libsanitizer/interception/Makefile.in: libsanitizer/interception/Makefile.am libsanitizer/aclocal.m4
171 libsanitizer/sanitizer_common/Makefile.in: libsanitizer/sanitizer_common/Makefile.am libsanitizer/aclocal.m4
172 libvtv/aclocal.m4: libvtv/configure.ac libvtv/acinclude.m4
173 libvtv/Makefile.in: libvtv/Makefile.am libvtv/aclocal.m4
174 libvtv/configure: libvtv/configure.ac libvtv/aclocal.m4
175 libbacktrace/aclocal.m4: libbacktrace/configure.ac
176 libbacktrace/Makefile.in: libbacktrace/Makefile.am libbacktrace/aclocal.m4
177 libbacktrace/configure: libbacktrace/configure.ac libbacktrace/aclocal.m4
178 libbacktrace/config.h.in: libbacktrace/configure.ac libbacktrace/aclocal.m4
179 libphobos/Makefile.in: libphobos/Makefile.am libphobos/configure.ac libphobos/aclocal.m4
180 libphobos/aclocal.m4: libphobos/configure.ac libphobos/acinclude.m4
181 libphobos/config.h.in: libphobos/configure.ac libphobos/aclocal.m4
182 libphobos/configure: libphobos/configure.ac libphobos/aclocal.m4
183 libphobos/src/Makefile.in: libphobos/src/Makefile.am libphobos/aclocal.m4
184 libphobos/testsuite/Makefile.in: libphobos/testsuite/Makefile.am libphobos/aclocal.m4
185 # Top level
186 Makefile.in: Makefile.tpl Makefile.def
187 configure: configure.ac config/acx.m4
192 # This function touches generated files such that the ``end'' user does
193 # not have to rebuild them.
194 touch_files () {
195 rm -f Makefile.$$
196 echo 'all: \' > Makefile.$$
197 files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
198 echo '; @true' >> Makefile.$$
199 files_and_dependencies | sed 's, ,: ,' >> Makefile.$$
200 files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
201 echo ':' >> Makefile.$$
202 echo ' @for f in $? $@; do test -f $$f || exit 0; done; \' >> Makefile.$$
203 echo ' echo Touching $@...; \' >> Makefile.$$
204 chat ' echo Touching $@... 1>&2; \' >> Makefile.$$
205 echo ' touch $@' >> Makefile.$$
206 files_and_dependencies | sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
208 # We would have to explicitly shut off the "Entering... Leaving..."
209 # messages through "--no-print-directory" to handle the case when
210 # we were called from a recursive invocation (i.e. "$(MAKE)" in a
211 # Makefile, not just make). Passing only "-s" doesn't help then,
212 # because make has helpfully added "-w" to MAKEFLAGS automatically.
213 # Unfortunately we do not require GNU make other than for building
214 # and testing, so let's just grep known text explicitly echoed by
215 # the rule.
216 while ${MAKE-make} -s -f Makefile.$$ all | grep Touching > /dev/null; do
217 sleep 1
218 done 2>&1
219 rm -f Makefile.$$
223 # Whenever we update the tree or install a patch, we may be modifying
224 # this script. By re-execing it, we ensure that the appropriate
225 # dependencies and rules will be used.
226 touch_files_reexec () {
227 chat "Adjusting file timestamps"
228 exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
231 # This functions applies a patch to an existing tree.
232 apply_patch () {
233 if [ -f "$1" ]; then
234 echo "Applying patch file $1"
235 case $1 in
236 *gz)
237 gzip -d -c "$1" | patch -p1 ;;
238 *bz2)
239 bzip2 -d -c "$1" | patch -p1 ;;
241 patch -p1 < "$1";;
242 esac
244 touch_files_reexec
247 # Check whether this indeed looks like a local tree.
248 if [ ! -f gcc/reload.cc ]; then
249 echo "This does not seem to be a GCC tree!"
250 exit
253 case "$1" in
254 --silent)
255 silent=t
256 shift
258 esac
260 case "$1" in
261 # First of all, check whether we are going to process a patch.
262 --patch)
263 if test "$#" != 2; then
264 echo "$1" expects only one argument >&2
265 exit 1
267 apply_patch "${2}"
268 exit $?
271 --touch)
272 if test "$#" != 1; then
273 echo "$1" does not expect any argument >&2
274 exit 1
276 touch_files
277 exit $?
280 --list)
281 if test "$#" != 1; then
282 echo "$1" does not expect any argument >&2
283 exit 1
285 files_and_dependencies | sed 's/ /: /'
286 exit $?
289 --help)
290 sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
294 }' \
295 -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
296 exit $?
299 esac
301 # Check for known version control systems.
302 if [ -d .git ] || [ -f .git ]; then
303 GCC_GIT=${GCC_GIT-${GIT-git}}
304 vcs_type="git"
305 elif [ -d .hg ]; then
306 GCC_HG=${GCC_HG-${HG-hg}}
307 vcs_type="hg"
308 elif [ -d .svn ]; then
309 GCC_SVN=${GCC_SVN-${SVN-svn}}
310 vcs_type="svn"
311 else
312 echo "This does not seem to be a GCC GIT/HG/SVN tree!"
313 exit
316 # Check command-line options
317 if [ x"${1}"x = x"--nostdflags"x ]; then
318 shift
319 else
320 set -- $UPDATE_OPTIONS ${1+"$@"}
323 case $vcs_type in
324 git)
325 chat "Updating GIT tree"
327 $GCC_GIT diff --quiet --exit-code HEAD
328 if [ $? -ne 0 ]; then
329 echo "Attempting to update a dirty git tree!" >&2
330 echo "Commit or stash your changes first and retry." >&2
331 exit 1
334 $GCC_GIT pull ${silent+-q} --rebase ${1+"$@"}
335 if [ $? -ne 0 ]; then
336 (touch_files_reexec)
337 echo "git pull of full tree failed." >&2
338 exit 1
341 # Open-coded version of "git gcc-descr" from contrib/gcc-git-customization.sh
342 revision=`$GCC_GIT log -n1 --pretty=tformat:%h`
343 r=`$GCC_GIT describe --all --match 'basepoints/gcc-[0-9]*' HEAD \
344 | sed -n 's,^\(tags/\)\?basepoints/gcc-\([0-9]\+\)-\([0-9]\+\)-g[0-9a-f]*$,r\2-\3,p;s,^\(tags/\)\?basepoints/gcc-\([0-9]\+\)$,r\2-0,p'`;
345 if test -n $r; then
346 o=`$GCC_GIT config --get gcc-config.upstream`;
347 rr=`echo $r | sed -n 's,^r\([0-9]\+\)-[0-9]\+\(-g[0-9a-f]\+\)\?$,\1,p'`;
348 if $GCC_GIT rev-parse --verify --quiet ${o:-origin}/releases/gcc-$rr >/dev/null; then
349 m=releases/gcc-$rr;
350 else
351 m=master;
353 if $GCC_GIT merge-base --is-ancestor HEAD ${o:-origin}/$m; then
354 revision=${r}-g${revision};
357 branch=`$GCC_GIT name-rev --name-only HEAD || :`
361 chat "Updating HG tree"
363 # Add -q so untracked files aren't listed.
364 if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
365 echo "Attempting to update a dirty hg tree!" >&2
366 echo "Commit or revert your changes first and retry." >&2
367 exit 1
370 # Check for mq extension. mq patches must be popped so tip has
371 # been converted from the SVN tree.
372 if [ -d .hg/patches ] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
373 # FIXME: Perhaps pop queue instead? We could do that since we
374 # know the tree is clean.
375 echo "Attempting to update hg tree with mq patches applied!" >&2
376 echo "Pop your patches first and retry." >&2
377 exit 1
380 # Update tree, but make sure to only pull the default branch.
381 # Otherwise all branches in the upstream repo are added, even if
382 # only a single one has been cloned.
383 $GCC_HG pull ${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
384 if [ $? -ne 0 ]; then
385 (touch_files_reexec)
386 echo "hg pull of full tree failed." >&2
387 exit 1
390 # Update tree. Needs to be done separately from pull so
391 # gcc_update -rREV works.
392 $GCC_HG update ${silent+-q} ${1+"$@"}
393 if [ $? -ne 0 ]; then
394 (touch_files_reexec)
395 echo "hg update of full tree failed." >&2
396 exit 1
399 # Extract SVN revision corresponding to parents, as stored by
400 # hg convert. Before hg 1.4.3, there's no template keyword
401 # corresponding to the extra: tag, so need to use hg log --debug
402 # to extract the info.
403 parents=`$GCC_HG parents --template '{rev}'`
404 convert_revision=`$GCC_HG log --debug -r$parents | \
405 sed -ne "/^extra:.*convert_revision=svn:/ {
406 s%^[^/]*/%%
409 revision=`echo $convert_revision | sed -e 's/.*@//'`
410 branch=`echo $convert_revision | sed -e 's%branches/%%' -e 's/@.*//'`
413 svn)
414 chat "Updating SVN tree"
416 $GCC_SVN ${silent+-q} --non-interactive update ${1+"$@"}
417 if [ $? -ne 0 ]; then
418 (touch_files_reexec)
419 echo "SVN update of full tree failed." >&2
420 exit 1
423 revision=`$GCC_SVN info | awk '/Revision:/ { print $2 }'`
424 branch=`$GCC_SVN info | sed -ne "/^URL:/ {
425 s,.*/trunk,trunk,
426 s,.*/branches/,,
427 s,.*/tags/,,
431 esac
433 rm -f LAST_UPDATED gcc/REVISION
435 date
436 echo "`TZ=UTC date` (revision $revision)"
437 } > LAST_UPDATED
438 echo "[$branch $revision]" > gcc/REVISION
440 touch_files_reexec